/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * Paths
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestUrlTestService.
 */
export interface Paths {

    /**
     * Get true Boolean value on path
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getBooleanTrue(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getBooleanTrue(callback: ServiceCallback<void>): void;

    /**
     * Get false Boolean value on path
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getBooleanFalse(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getBooleanFalse(callback: ServiceCallback<void>): void;

    /**
     * Get '1000000' integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getIntOneMillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getIntOneMillion(callback: ServiceCallback<void>): void;

    /**
     * Get '-1000000' integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getIntNegativeOneMillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getIntNegativeOneMillion(callback: ServiceCallback<void>): void;

    /**
     * Get '10000000000' 64 bit integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getTenBillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getTenBillion(callback: ServiceCallback<void>): void;

    /**
     * Get '-10000000000' 64 bit integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getNegativeTenBillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getNegativeTenBillion(callback: ServiceCallback<void>): void;

    /**
     * Get '1.034E+20' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    floatScientificPositive(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    floatScientificPositive(callback: ServiceCallback<void>): void;

    /**
     * Get '-1.034E-20' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    floatScientificNegative(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    floatScientificNegative(callback: ServiceCallback<void>): void;

    /**
     * Get '9999999.999' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    doubleDecimalPositive(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    doubleDecimalPositive(callback: ServiceCallback<void>): void;

    /**
     * Get '-9999999.999' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    doubleDecimalNegative(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    doubleDecimalNegative(callback: ServiceCallback<void>): void;

    /**
     * Get '啊齄丂狛狜隣郎隣兀﨩' multi-byte string value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringUnicode(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringUnicode(callback: ServiceCallback<void>): void;

    /**
     * Get 'begin!*'();:@ &=+$,/?#[]end
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringUrlEncoded(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringUrlEncoded(callback: ServiceCallback<void>): void;

    /**
     * Get ''
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringEmpty(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringEmpty(callback: ServiceCallback<void>): void;

    /**
     * Get null (should throw)
     *
     * @param {string} stringPath null string value
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringNull(stringPath: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringNull(stringPath: string, callback: ServiceCallback<void>): void;

    /**
     * Get using uri with 'green color' in path parameter
     *
     * @param {string} enumPath send the value green. Possible values include:
     * 'red color', 'green color', 'blue color'
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    enumValid(enumPath: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    enumValid(enumPath: string, callback: ServiceCallback<void>): void;

    /**
     * Get null (should throw on the client before the request is sent on wire)
     *
     * @param {string} enumPath send null should throw. Possible values include:
     * 'red color', 'green color', 'blue color'
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    enumNull(enumPath: string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    enumNull(enumPath: string, callback: ServiceCallback<void>): void;

    /**
     * Get '啊齄丂狛狜隣郎隣兀﨩' multibyte value as utf-8 encoded byte array
     *
     * @param {buffer} bytePath '啊齄丂狛狜隣郎隣兀﨩' multibyte value as utf-8 encoded byte
     * array
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteMultiByte(bytePath: Buffer, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteMultiByte(bytePath: Buffer, callback: ServiceCallback<void>): void;

    /**
     * Get '' as byte array
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteEmpty(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteEmpty(callback: ServiceCallback<void>): void;

    /**
     * Get null as byte array (should throw)
     *
     * @param {buffer} bytePath null as byte array (should throw)
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteNull(bytePath: Buffer, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteNull(bytePath: Buffer, callback: ServiceCallback<void>): void;

    /**
     * Get '2012-01-01' as date
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateValid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateValid(callback: ServiceCallback<void>): void;

    /**
     * Get null as date - this should throw or be unusable on the client side,
     * depending on date representation
     *
     * @param {date} datePath null as date (should throw)
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateNull(datePath: Date|string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateNull(datePath: Date|string, callback: ServiceCallback<void>): void;

    /**
     * Get '2012-01-01T01:01:01Z' as date-time
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateTimeValid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateTimeValid(callback: ServiceCallback<void>): void;

    /**
     * Get null as date-time, should be disallowed or throw depending on
     * representation of date-time
     *
     * @param {date} dateTimePath null as date-time
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateTimeNull(dateTimePath: Date|string, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateTimeNull(dateTimePath: Date|string, callback: ServiceCallback<void>): void;

    /**
     * Get 'lorem' encoded value as 'bG9yZW0' (base64url)
     *
     * @param {buffer} base64UrlPath base64url encoded value
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    base64Url(base64UrlPath: Buffer, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    base64Url(base64UrlPath: Buffer, callback: ServiceCallback<void>): void;

    /**
     * Get an array of string ['ArrayPath1', 'begin!*'();:@ &=+$,/?#[]end' , null,
     * ''] using the csv-array format
     *
     * @param {array} arrayPath an array of string ['ArrayPath1', 'begin!*'();:@
     * &=+$,/?#[]end' , null, ''] using the csv-array format
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayCsvInPath(arrayPath: string[], options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayCsvInPath(arrayPath: string[], callback: ServiceCallback<void>): void;

    /**
     * Get the date 2016-04-13 encoded value as '1460505600' (Unix time)
     *
     * @param {date} unixTimeUrlPath Unix time encoded value
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    unixTimeUrl(unixTimeUrlPath: Date, options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    unixTimeUrl(unixTimeUrlPath: Date, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * Queries
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestUrlTestService.
 */
export interface Queries {

    /**
     * Get true Boolean value on path
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getBooleanTrue(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getBooleanTrue(callback: ServiceCallback<void>): void;

    /**
     * Get false Boolean value on path
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getBooleanFalse(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getBooleanFalse(callback: ServiceCallback<void>): void;

    /**
     * Get null Boolean value on query (query string should be absent)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.boolQuery] null boolean value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getBooleanNull(options: { boolQuery? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getBooleanNull(callback: ServiceCallback<void>): void;

    /**
     * Get '1000000' integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getIntOneMillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getIntOneMillion(callback: ServiceCallback<void>): void;

    /**
     * Get '-1000000' integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getIntNegativeOneMillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getIntNegativeOneMillion(callback: ServiceCallback<void>): void;

    /**
     * Get null integer value (no query parameter)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {number} [options.intQuery] null integer value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getIntNull(options: { intQuery? : number, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getIntNull(callback: ServiceCallback<void>): void;

    /**
     * Get '10000000000' 64 bit integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getTenBillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getTenBillion(callback: ServiceCallback<void>): void;

    /**
     * Get '-10000000000' 64 bit integer value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getNegativeTenBillion(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getNegativeTenBillion(callback: ServiceCallback<void>): void;

    /**
     * Get 'null 64 bit integer value (no query param in uri)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {number} [options.longQuery] null 64 bit integer value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getLongNull(options: { longQuery? : number, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getLongNull(callback: ServiceCallback<void>): void;

    /**
     * Get '1.034E+20' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    floatScientificPositive(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    floatScientificPositive(callback: ServiceCallback<void>): void;

    /**
     * Get '-1.034E-20' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    floatScientificNegative(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    floatScientificNegative(callback: ServiceCallback<void>): void;

    /**
     * Get null numeric value (no query parameter)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {number} [options.floatQuery] null numeric value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    floatNull(options: { floatQuery? : number, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    floatNull(callback: ServiceCallback<void>): void;

    /**
     * Get '9999999.999' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    doubleDecimalPositive(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    doubleDecimalPositive(callback: ServiceCallback<void>): void;

    /**
     * Get '-9999999.999' numeric value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    doubleDecimalNegative(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    doubleDecimalNegative(callback: ServiceCallback<void>): void;

    /**
     * Get null numeric value (no query parameter)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {number} [options.doubleQuery] null numeric value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    doubleNull(options: { doubleQuery? : number, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    doubleNull(callback: ServiceCallback<void>): void;

    /**
     * Get '啊齄丂狛狜隣郎隣兀﨩' multi-byte string value
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringUnicode(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringUnicode(callback: ServiceCallback<void>): void;

    /**
     * Get 'begin!*'();:@ &=+$,/?#[]end
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringUrlEncoded(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringUrlEncoded(callback: ServiceCallback<void>): void;

    /**
     * Get ''
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringEmpty(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringEmpty(callback: ServiceCallback<void>): void;

    /**
     * Get null (no query parameter in url)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.stringQuery] null string value
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    stringNull(options: { stringQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    stringNull(callback: ServiceCallback<void>): void;

    /**
     * Get using uri with query parameter 'green color'
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.enumQuery] 'green color' enum value. Possible
     * values include: 'red color', 'green color', 'blue color'
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    enumValid(options: { enumQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    enumValid(callback: ServiceCallback<void>): void;

    /**
     * Get null (no query parameter in url)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.enumQuery] null string value. Possible values
     * include: 'red color', 'green color', 'blue color'
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    enumNull(options: { enumQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    enumNull(callback: ServiceCallback<void>): void;

    /**
     * Get '啊齄丂狛狜隣郎隣兀﨩' multibyte value as utf-8 encoded byte array
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {buffer} [options.byteQuery] '啊齄丂狛狜隣郎隣兀﨩' multibyte value as utf-8
     * encoded byte array
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteMultiByte(options: { byteQuery? : Buffer, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteMultiByte(callback: ServiceCallback<void>): void;

    /**
     * Get '' as byte array
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteEmpty(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteEmpty(callback: ServiceCallback<void>): void;

    /**
     * Get null as byte array (no query parameters in uri)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {buffer} [options.byteQuery] null as byte array (no query parameters
     * in uri)
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    byteNull(options: { byteQuery? : Buffer, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    byteNull(callback: ServiceCallback<void>): void;

    /**
     * Get '2012-01-01' as date
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateValid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateValid(callback: ServiceCallback<void>): void;

    /**
     * Get null as date - this should result in no query parameters in uri
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {date} [options.dateQuery] null as date (no query parameters in uri)
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateNull(options: { dateQuery? : Date, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateNull(callback: ServiceCallback<void>): void;

    /**
     * Get '2012-01-01T01:01:01Z' as date-time
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateTimeValid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateTimeValid(callback: ServiceCallback<void>): void;

    /**
     * Get null as date-time, should result in no query parameters in uri
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {date} [options.dateTimeQuery] null as date-time (no query
     * parameters)
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    dateTimeNull(options: { dateTimeQuery? : Date, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    dateTimeNull(callback: ServiceCallback<void>): void;

    /**
     * Get an array of string ['ArrayQuery1', 'begin!*'();:@ &=+$,/?#[]end' ,
     * null, ''] using the csv-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] an array of string ['ArrayQuery1',
     * 'begin!*'();:@ &=+$,/?#[]end' , null, ''] using the csv-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringCsvValid(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringCsvValid(callback: ServiceCallback<void>): void;

    /**
     * Get a null array of string using the csv-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] a null array of string using the
     * csv-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringCsvNull(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringCsvNull(callback: ServiceCallback<void>): void;

    /**
     * Get an empty array [] of string using the csv-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] an empty array [] of string using the
     * csv-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringCsvEmpty(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringCsvEmpty(callback: ServiceCallback<void>): void;

    /**
     * Get an array of string ['ArrayQuery1', 'begin!*'();:@ &=+$,/?#[]end' ,
     * null, ''] using the ssv-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] an array of string ['ArrayQuery1',
     * 'begin!*'();:@ &=+$,/?#[]end' , null, ''] using the ssv-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringSsvValid(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringSsvValid(callback: ServiceCallback<void>): void;

    /**
     * Get an array of string ['ArrayQuery1', 'begin!*'();:@ &=+$,/?#[]end' ,
     * null, ''] using the tsv-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] an array of string ['ArrayQuery1',
     * 'begin!*'();:@ &=+$,/?#[]end' , null, ''] using the tsv-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringTsvValid(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringTsvValid(callback: ServiceCallback<void>): void;

    /**
     * Get an array of string ['ArrayQuery1', 'begin!*'();:@ &=+$,/?#[]end' ,
     * null, ''] using the pipes-array format
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {array} [options.arrayQuery] an array of string ['ArrayQuery1',
     * 'begin!*'();:@ &=+$,/?#[]end' , null, ''] using the pipes-array format
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    arrayStringPipesValid(options: { arrayQuery? : string[], customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    arrayStringPipesValid(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * PathItems
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestUrlTestService.
 */
export interface PathItems {

    /**
     * send globalStringPath='globalStringPath',
     * pathItemStringPath='pathItemStringPath',
     * localStringPath='localStringPath', globalStringQuery='globalStringQuery',
     * pathItemStringQuery='pathItemStringQuery',
     * localStringQuery='localStringQuery'
     *
     * @param {string} localStringPath should contain value 'localStringPath'
     * 
     * @param {string} pathItemStringPath A string value 'pathItemStringPath' that
     * appears in the path
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.localStringQuery] should contain value
     * 'localStringQuery'
     * 
     * @param {string} [options.pathItemStringQuery] A string value
     * 'pathItemStringQuery' that appears as a query parameter
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getAllWithValues(localStringPath: string, pathItemStringPath: string, options: { localStringQuery? : string, pathItemStringQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getAllWithValues(localStringPath: string, pathItemStringPath: string, callback: ServiceCallback<void>): void;

    /**
     * send globalStringPath='globalStringPath',
     * pathItemStringPath='pathItemStringPath',
     * localStringPath='localStringPath', globalStringQuery=null,
     * pathItemStringQuery='pathItemStringQuery',
     * localStringQuery='localStringQuery'
     *
     * @param {string} localStringPath should contain value 'localStringPath'
     * 
     * @param {string} pathItemStringPath A string value 'pathItemStringPath' that
     * appears in the path
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.localStringQuery] should contain value
     * 'localStringQuery'
     * 
     * @param {string} [options.pathItemStringQuery] A string value
     * 'pathItemStringQuery' that appears as a query parameter
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getGlobalQueryNull(localStringPath: string, pathItemStringPath: string, options: { localStringQuery? : string, pathItemStringQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getGlobalQueryNull(localStringPath: string, pathItemStringPath: string, callback: ServiceCallback<void>): void;

    /**
     * send globalStringPath=globalStringPath,
     * pathItemStringPath='pathItemStringPath',
     * localStringPath='localStringPath', globalStringQuery=null,
     * pathItemStringQuery='pathItemStringQuery', localStringQuery=null
     *
     * @param {string} localStringPath should contain value 'localStringPath'
     * 
     * @param {string} pathItemStringPath A string value 'pathItemStringPath' that
     * appears in the path
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.localStringQuery] should contain null value
     * 
     * @param {string} [options.pathItemStringQuery] A string value
     * 'pathItemStringQuery' that appears as a query parameter
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getGlobalAndLocalQueryNull(localStringPath: string, pathItemStringPath: string, options: { localStringQuery? : string, pathItemStringQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getGlobalAndLocalQueryNull(localStringPath: string, pathItemStringPath: string, callback: ServiceCallback<void>): void;

    /**
     * send globalStringPath='globalStringPath',
     * pathItemStringPath='pathItemStringPath',
     * localStringPath='localStringPath', globalStringQuery='globalStringQuery',
     * pathItemStringQuery=null, localStringQuery=null
     *
     * @param {string} localStringPath should contain value 'localStringPath'
     * 
     * @param {string} pathItemStringPath A string value 'pathItemStringPath' that
     * appears in the path
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.localStringQuery] should contain value null
     * 
     * @param {string} [options.pathItemStringQuery] should contain value null
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getLocalPathItemQueryNull(localStringPath: string, pathItemStringPath: string, options: { localStringQuery? : string, pathItemStringQuery? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getLocalPathItemQueryNull(localStringPath: string, pathItemStringPath: string, callback: ServiceCallback<void>): void;
}
